/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker;

import fr.supelec.adlv.checker.logic.Always;
import fr.supelec.adlv.checker.logic.BackTo;
import fr.supelec.adlv.checker.logic.Expr;
import fr.supelec.adlv.checker.logic.Implies;
import fr.supelec.adlv.checker.logic.Not;
import fr.supelec.adlv.checker.logic.Once;
import fr.supelec.adlv.checker.logic.Or;
import fr.supelec.adlv.checker.logic.Since;

public abstract class DefaultAbstractCheckingCodeGenerator implements CheckingCodeGenerator {
	public void visit(BackTo backTo) {
		visit(new Or(
				new Always(backTo.getA()),
				new Since(backTo.getA(), backTo.getB())));

	}

	public void visit(Once once) {
		visit(new Not(
				new Always(
						new Not(
								once.getExpr()))));
	}

	public void visit(Implies implies) {
		visit(new Or(
				new Not(implies.getA()),
				implies.getB()));
	}

	protected void notHandled(Expr expr) {
		throw new RuntimeException(
				"Expressions of type '" + expr.getClass().getSimpleName() +
				"' not handled by generator '" + getClass().getSimpleName() + "'");

	}

}
