/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker;

public class GenerationException extends Exception {
	private final CheckingCodeGenerator generator;
	private final String message;
	private static final long serialVersionUID = 8300260192355196655L;

	public GenerationException(CheckingCodeGenerator generator, String message) {
		super(generator.getName() + ": " + message);
		this.generator = generator;
		this.message = message;
	}

	@Override
	public String toString() {
		return generator.getName() + ": " + message;
	}
}
