/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker;

public class LogFacility {
	public void info(Object ... msg) {
		output("INFO", msg);
	}

	public void err(Object ... msg) {
		output("ERR", msg);
		throw new RuntimeException(msg[0].toString());
	}

	public void warn(Object ... msg) {
		output("WARN", msg);
	}

	public void debug(Object ... msg) {
		output("DBG", msg);
	}

	private void output(String type, Object ... msg) {
		for(Object m : msg) {
			String s = m.toString();
			String[] lines = s.split("\n");
			for(String line : lines)
				System.out.println("[" + type + "] " + line);
		}
	}
}
