/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;

/**
 * Classes implementing this interface are able to visit any kind of
 * pattern.
 *
 */
public interface ExprVisitor {
	public void visit(Interval interval);
	public void visit(And and);
	public void visit(Or or);
	public void visit(Not not);
	public void visit(Since since);
	public void visit(BackTo backTo);
	public void visit(Previous previous);
	public void visit(Always always);
	public void visit(Once once);
	public void visit(Implies implies);
	public void visit(Constant constant);
}
