/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;

import fr.supelec.adlv.AdlvFactory;
import fr.supelec.adlv.Component;
import fr.supelec.adlv.Port;
import fr.supelec.adlv.checker.PortInstance;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Expr a = mkSignalPredicate("a");
		Expr b = mkSignalPredicate("b");

		Expr or = new Or(a, b);
		Expr and = new And(a, b);

		System.out.println("Comparaison \"" + or + "\" et \"" + and + "\": " + or.compare(and));
		System.out.println("Comparaison \"" + and + "\" et \"" + or + "\": " + and.compare(or));

		/*NaryExpr z = (NaryExpr)(new Or(new Or(new Not(or), and), b).canonical(false));
		System.out.println("z = " + z);
		for(Predicate p : z.iterableOverPredicates(null)) {
			System.out.println("\t" + p);
		}*/
	}


	private static SignalPredicate mkSignalPredicate(String name) {
		Port p = AdlvFactory.eINSTANCE.createConsumerPort();
		Component c = AdlvFactory.eINSTANCE.createComponent();
		p.setName(name);
		c.setName("test");
		return new SignalPredicate(true, PortInstance.make(p, c));
	}

}
