/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.ComponentType#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.ComponentType#getTool <em>Tool</em>}</li>
 *   <li>{@link fr.supelec.adlv.ComponentType#getPorts <em>Ports</em>}</li>
 *   <li>{@link fr.supelec.adlv.ComponentType#getComponent <em>Component</em>}</li>
 *   <li>{@link fr.supelec.adlv.ComponentType#getModule <em>Module</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getComponentType()
 * @model abstract="true"
 * @generated
 */
public interface ComponentType extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.supelec.adlv.AdlvPackage#getComponentType_Name()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ComponentType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Tool</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tool</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tool</em>' attribute.
	 * @see #setTool(String)
	 * @see fr.supelec.adlv.AdlvPackage#getComponentType_Tool()
	 * @model unique="false" ordered="false"
	 * @generated
	 */
	String getTool();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ComponentType#getTool <em>Tool</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tool</em>' attribute.
	 * @see #getTool()
	 * @generated
	 */
	void setTool(String value);

	/**
	 * Returns the value of the '<em><b>Ports</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Port}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Port#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ports</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ports</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getComponentType_Ports()
	 * @see fr.supelec.adlv.Port#getComponent
	 * @model opposite="component" containment="true" ordered="false"
	 * @generated
	 */
	EList<Port> getPorts();

	/**
	 * Returns the value of the '<em><b>Component</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Component}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Component#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getComponentType_Component()
	 * @see fr.supelec.adlv.Component#getType
	 * @model opposite="type" ordered="false"
	 * @generated
	 */
	EList<Component> getComponent();

	/**
	 * Returns the value of the '<em><b>Module</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Module#getComponentTypes <em>Component Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Module</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Module</em>' container reference.
	 * @see #setModule(Module)
	 * @see fr.supelec.adlv.AdlvPackage#getComponentType_Module()
	 * @see fr.supelec.adlv.Module#getComponentTypes
	 * @model opposite="componentTypes" required="true" transient="false" ordered="false"
	 * @generated
	 */
	Module getModule();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ComponentType#getModule <em>Module</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Module</em>' container reference.
	 * @see #getModule()
	 * @generated
	 */
	void setModule(Module value);

} // ComponentType
