/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Expression</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.Expression#getProducerPort <em>Producer Port</em>}</li>
 *   <li>{@link fr.supelec.adlv.Expression#getUnaryExpression <em>Unary Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.Expression#getCompareRight <em>Compare Right</em>}</li>
 *   <li>{@link fr.supelec.adlv.Expression#getCompareLeft <em>Compare Left</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getExpression()
 * @model abstract="true"
 * @generated
 */
public interface Expression extends EObject {
	/**
	 * Returns the value of the '<em><b>Producer Port</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ProducerPort}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ProducerPort#getEventEmitExpression <em>Event Emit Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Producer Port</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Producer Port</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getExpression_ProducerPort()
	 * @see fr.supelec.adlv.ProducerPort#getEventEmitExpression
	 * @model opposite="eventEmitExpression" ordered="false"
	 * @generated
	 */
	EList<ProducerPort> getProducerPort();

	/**
	 * Returns the value of the '<em><b>Unary Expression</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.UnaryExpression#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unary Expression</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unary Expression</em>' container reference.
	 * @see #setUnaryExpression(UnaryExpression)
	 * @see fr.supelec.adlv.AdlvPackage#getExpression_UnaryExpression()
	 * @see fr.supelec.adlv.UnaryExpression#getExpression
	 * @model opposite="expression" transient="false" ordered="false"
	 * @generated
	 */
	UnaryExpression getUnaryExpression();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Expression#getUnaryExpression <em>Unary Expression</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unary Expression</em>' container reference.
	 * @see #getUnaryExpression()
	 * @generated
	 */
	void setUnaryExpression(UnaryExpression value);

	/**
	 * Returns the value of the '<em><b>Compare Right</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.BinaryExpression#getRightExpression <em>Right Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Compare Right</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Compare Right</em>' container reference.
	 * @see #setCompareRight(BinaryExpression)
	 * @see fr.supelec.adlv.AdlvPackage#getExpression_CompareRight()
	 * @see fr.supelec.adlv.BinaryExpression#getRightExpression
	 * @model opposite="rightExpression" transient="false" ordered="false"
	 * @generated
	 */
	BinaryExpression getCompareRight();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Expression#getCompareRight <em>Compare Right</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Compare Right</em>' container reference.
	 * @see #getCompareRight()
	 * @generated
	 */
	void setCompareRight(BinaryExpression value);

	/**
	 * Returns the value of the '<em><b>Compare Left</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.BinaryExpression#getLeftExpression <em>Left Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Compare Left</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Compare Left</em>' container reference.
	 * @see #setCompareLeft(BinaryExpression)
	 * @see fr.supelec.adlv.AdlvPackage#getExpression_CompareLeft()
	 * @see fr.supelec.adlv.BinaryExpression#getLeftExpression
	 * @model opposite="leftExpression" transient="false" ordered="false"
	 * @generated
	 */
	BinaryExpression getCompareLeft();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Expression#getCompareLeft <em>Compare Left</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Compare Left</em>' container reference.
	 * @see #getCompareLeft()
	 * @generated
	 */
	void setCompareLeft(BinaryExpression value);

} // Expression
