/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Module</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.Module#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.Module#getApplication <em>Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.Module#getComponentTypes <em>Component Types</em>}</li>
 *   <li>{@link fr.supelec.adlv.Module#getTokenTypes <em>Token Types</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getModule()
 * @model
 * @generated
 */
public interface Module extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.supelec.adlv.AdlvPackage#getModule_Name()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Module#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Application</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Application}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Application#getModule <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Application</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Application</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getModule_Application()
	 * @see fr.supelec.adlv.Application#getModule
	 * @model opposite="module" containment="true" ordered="false"
	 * @generated
	 */
	EList<Application> getApplication();

	/**
	 * Returns the value of the '<em><b>Component Types</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ComponentType}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ComponentType#getModule <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component Types</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component Types</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getModule_ComponentTypes()
	 * @see fr.supelec.adlv.ComponentType#getModule
	 * @model opposite="module" containment="true" ordered="false"
	 * @generated
	 */
	EList<ComponentType> getComponentTypes();

	/**
	 * Returns the value of the '<em><b>Token Types</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.TokenType}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.TokenType#getModule <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Token Types</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Token Types</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getModule_TokenTypes()
	 * @see fr.supelec.adlv.TokenType#getModule
	 * @model opposite="module" containment="true" ordered="false"
	 * @generated
	 */
	EList<TokenType> getTokenTypes();

} // Module
