/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Producer Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.ProducerPort#getOutputAttribute <em>Output Attribute</em>}</li>
 *   <li>{@link fr.supelec.adlv.ProducerPort#getEventEmitExpression <em>Event Emit Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getProducerPort()
 * @model
 * @generated
 */
public interface ProducerPort extends Port {
	/**
	 * Returns the value of the '<em><b>Output Attribute</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Output Attribute</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Output Attribute</em>' reference.
	 * @see #setOutputAttribute(Attribute)
	 * @see fr.supelec.adlv.AdlvPackage#getProducerPort_OutputAttribute()
	 * @model ordered="false"
	 * @generated
	 */
	Attribute getOutputAttribute();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ProducerPort#getOutputAttribute <em>Output Attribute</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Output Attribute</em>' reference.
	 * @see #getOutputAttribute()
	 * @generated
	 */
	void setOutputAttribute(Attribute value);

	/**
	 * Returns the value of the '<em><b>Event Emit Expression</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Expression#getProducerPort <em>Producer Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Emit Expression</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Emit Expression</em>' reference.
	 * @see #setEventEmitExpression(Expression)
	 * @see fr.supelec.adlv.AdlvPackage#getProducerPort_EventEmitExpression()
	 * @see fr.supelec.adlv.Expression#getProducerPort
	 * @model opposite="producerPort" ordered="false"
	 * @generated
	 */
	Expression getEventEmitExpression();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ProducerPort#getEventEmitExpression <em>Event Emit Expression</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Emit Expression</em>' reference.
	 * @see #getEventEmitExpression()
	 * @generated
	 */
	void setEventEmitExpression(Expression value);

} // ProducerPort
