/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AdlvFactoryImpl extends EFactoryImpl implements AdlvFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AdlvFactory init() {
		try {
			AdlvFactory theAdlvFactory = (AdlvFactory)EPackage.Registry.INSTANCE.getEFactory("http:///fr/supelec/adlv.ecore"); 
			if (theAdlvFactory != null) {
				return theAdlvFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new AdlvFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlvFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case AdlvPackage.APPLICATION: return createApplication();
			case AdlvPackage.MODULE: return createModule();
			case AdlvPackage.COMPONENT: return createComponent();
			case AdlvPackage.CONSUMER_PORT: return createConsumerPort();
			case AdlvPackage.PRODUCER_PORT: return createProducerPort();
			case AdlvPackage.ATTRIBUTE: return createAttribute();
			case AdlvPackage.INTERNAL_COMPONENT_TYPE: return createInternalComponentType();
			case AdlvPackage.UNARY_EXPRESSION: return createUnaryExpression();
			case AdlvPackage.BINARY_EXPRESSION: return createBinaryExpression();
			case AdlvPackage.CONNECTION: return createConnection();
			case AdlvPackage.CONNECTION_CONFIGURATION_STEP: return createConnectionConfigurationStep();
			case AdlvPackage.PORT_EXPRESSION: return createPortExpression();
			case AdlvPackage.SAFETY_CLAUSE: return createSafetyClause();
			case AdlvPackage.LITERAL_EXPRESSION: return createLiteralExpression();
			case AdlvPackage.EVENT_TYPE: return createEventType();
			case AdlvPackage.STREAM_TYPE: return createStreamType();
			case AdlvPackage.CONTROL_COMPONENT_TYPE: return createControlComponentType();
			case AdlvPackage.PROCESSING_COMPONENT_TYPE: return createProcessingComponentType();
			case AdlvPackage.ACTIVATE_COMPONENT_STEP: return createActivateComponentStep();
			case AdlvPackage.DEACTIVATE_COMPONENT_STEP: return createDeactivateComponentStep();
			case AdlvPackage.ALWAYS_CLAUSE: return createAlwaysClause();
			case AdlvPackage.NEVER_CLAUSE: return createNeverClause();
			case AdlvPackage.ACTIVE_EXPRESSION: return createActiveExpression();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case AdlvPackage.DATA_TYPE:
				return createDataTypeFromString(eDataType, initialValue);
			case AdlvPackage.UNARY_OPERATOR:
				return createUnaryOperatorFromString(eDataType, initialValue);
			case AdlvPackage.BINARY_OPERATOR:
				return createBinaryOperatorFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case AdlvPackage.DATA_TYPE:
				return convertDataTypeToString(eDataType, instanceValue);
			case AdlvPackage.UNARY_OPERATOR:
				return convertUnaryOperatorToString(eDataType, instanceValue);
			case AdlvPackage.BINARY_OPERATOR:
				return convertBinaryOperatorToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application createApplication() {
		ApplicationImpl application = new ApplicationImpl();
		return application;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Module createModule() {
		ModuleImpl module = new ModuleImpl();
		return module;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Component createComponent() {
		ComponentImpl component = new ComponentImpl();
		return component;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConsumerPort createConsumerPort() {
		ConsumerPortImpl consumerPort = new ConsumerPortImpl();
		return consumerPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProducerPort createProducerPort() {
		ProducerPortImpl producerPort = new ProducerPortImpl();
		return producerPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attribute createAttribute() {
		AttributeImpl attribute = new AttributeImpl();
		return attribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InternalComponentType createInternalComponentType() {
		InternalComponentTypeImpl internalComponentType = new InternalComponentTypeImpl();
		return internalComponentType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnaryExpression createUnaryExpression() {
		UnaryExpressionImpl unaryExpression = new UnaryExpressionImpl();
		return unaryExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryExpression createBinaryExpression() {
		BinaryExpressionImpl binaryExpression = new BinaryExpressionImpl();
		return binaryExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Connection createConnection() {
		ConnectionImpl connection = new ConnectionImpl();
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConnectionConfigurationStep createConnectionConfigurationStep() {
		ConnectionConfigurationStepImpl connectionConfigurationStep = new ConnectionConfigurationStepImpl();
		return connectionConfigurationStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PortExpression createPortExpression() {
		PortExpressionImpl portExpression = new PortExpressionImpl();
		return portExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SafetyClause createSafetyClause() {
		SafetyClauseImpl safetyClause = new SafetyClauseImpl();
		return safetyClause;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LiteralExpression createLiteralExpression() {
		LiteralExpressionImpl literalExpression = new LiteralExpressionImpl();
		return literalExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventType createEventType() {
		EventTypeImpl eventType = new EventTypeImpl();
		return eventType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StreamType createStreamType() {
		StreamTypeImpl streamType = new StreamTypeImpl();
		return streamType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ControlComponentType createControlComponentType() {
		ControlComponentTypeImpl controlComponentType = new ControlComponentTypeImpl();
		return controlComponentType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProcessingComponentType createProcessingComponentType() {
		ProcessingComponentTypeImpl processingComponentType = new ProcessingComponentTypeImpl();
		return processingComponentType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActivateComponentStep createActivateComponentStep() {
		ActivateComponentStepImpl activateComponentStep = new ActivateComponentStepImpl();
		return activateComponentStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeactivateComponentStep createDeactivateComponentStep() {
		DeactivateComponentStepImpl deactivateComponentStep = new DeactivateComponentStepImpl();
		return deactivateComponentStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AlwaysClause createAlwaysClause() {
		AlwaysClauseImpl alwaysClause = new AlwaysClauseImpl();
		return alwaysClause;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NeverClause createNeverClause() {
		NeverClauseImpl neverClause = new NeverClauseImpl();
		return neverClause;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActiveExpression createActiveExpression() {
		ActiveExpressionImpl activeExpression = new ActiveExpressionImpl();
		return activeExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataType createDataTypeFromString(EDataType eDataType, String initialValue) {
		DataType result = DataType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDataTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnaryOperator createUnaryOperatorFromString(EDataType eDataType, String initialValue) {
		UnaryOperator result = UnaryOperator.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertUnaryOperatorToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryOperator createBinaryOperatorFromString(EDataType eDataType, String initialValue) {
		BinaryOperator result = BinaryOperator.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertBinaryOperatorToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlvPackage getAdlvPackage() {
		return (AdlvPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static AdlvPackage getPackage() {
		return AdlvPackage.eINSTANCE;
	}

} //AdlvFactoryImpl
