/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Application;
import fr.supelec.adlv.Component;
import fr.supelec.adlv.Connection;
import fr.supelec.adlv.ConnectionConfigurationStep;
import fr.supelec.adlv.Port;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Connection</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getFromComponent <em>From Component</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getConnectionConfigurationStep <em>Connection Configuration Step</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getFromApplication <em>From Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getToApplication <em>To Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getToPort <em>To Port</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getFromPort <em>From Port</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConnectionImpl#getToComponent <em>To Component</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConnectionImpl extends EObjectImpl implements Connection {
	/**
	 * The cached value of the '{@link #getFromComponent() <em>From Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromComponent()
	 * @generated
	 * @ordered
	 */
	protected Component fromComponent;

	/**
	 * The cached value of the '{@link #getConnectionConfigurationStep() <em>Connection Configuration Step</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnectionConfigurationStep()
	 * @generated
	 * @ordered
	 */
	protected EList<ConnectionConfigurationStep> connectionConfigurationStep;

	/**
	 * The cached value of the '{@link #getFromApplication() <em>From Application</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromApplication()
	 * @generated
	 * @ordered
	 */
	protected Application fromApplication;

	/**
	 * The cached value of the '{@link #getToApplication() <em>To Application</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToApplication()
	 * @generated
	 * @ordered
	 */
	protected Application toApplication;

	/**
	 * The cached value of the '{@link #getToPort() <em>To Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToPort()
	 * @generated
	 * @ordered
	 */
	protected Port toPort;

	/**
	 * The cached value of the '{@link #getFromPort() <em>From Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFromPort()
	 * @generated
	 * @ordered
	 */
	protected Port fromPort;

	/**
	 * The cached value of the '{@link #getToComponent() <em>To Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getToComponent()
	 * @generated
	 * @ordered
	 */
	protected Component toComponent;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConnectionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.CONNECTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Component getFromComponent() {
		if (fromComponent != null && fromComponent.eIsProxy()) {
			InternalEObject oldFromComponent = (InternalEObject)fromComponent;
			fromComponent = (Component)eResolveProxy(oldFromComponent);
			if (fromComponent != oldFromComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONNECTION__FROM_COMPONENT, oldFromComponent, fromComponent));
			}
		}
		return fromComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Component basicGetFromComponent() {
		return fromComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFromComponent(Component newFromComponent, NotificationChain msgs) {
		Component oldFromComponent = fromComponent;
		fromComponent = newFromComponent;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__FROM_COMPONENT, oldFromComponent, newFromComponent);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromComponent(Component newFromComponent) {
		if (newFromComponent != fromComponent) {
			NotificationChain msgs = null;
			if (fromComponent != null)
				msgs = ((InternalEObject)fromComponent).eInverseRemove(this, AdlvPackage.COMPONENT__OUTPUT_CONNECTION, Component.class, msgs);
			if (newFromComponent != null)
				msgs = ((InternalEObject)newFromComponent).eInverseAdd(this, AdlvPackage.COMPONENT__OUTPUT_CONNECTION, Component.class, msgs);
			msgs = basicSetFromComponent(newFromComponent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__FROM_COMPONENT, newFromComponent, newFromComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ConnectionConfigurationStep> getConnectionConfigurationStep() {
		if (connectionConfigurationStep == null) {
			connectionConfigurationStep = new EObjectWithInverseResolvingEList<ConnectionConfigurationStep>(ConnectionConfigurationStep.class, this, AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP, AdlvPackage.CONNECTION_CONFIGURATION_STEP__CONNECTION);
		}
		return connectionConfigurationStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application getFromApplication() {
		if (fromApplication != null && fromApplication.eIsProxy()) {
			InternalEObject oldFromApplication = (InternalEObject)fromApplication;
			fromApplication = (Application)eResolveProxy(oldFromApplication);
			if (fromApplication != oldFromApplication) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONNECTION__FROM_APPLICATION, oldFromApplication, fromApplication));
			}
		}
		return fromApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application basicGetFromApplication() {
		return fromApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFromApplication(Application newFromApplication, NotificationChain msgs) {
		Application oldFromApplication = fromApplication;
		fromApplication = newFromApplication;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__FROM_APPLICATION, oldFromApplication, newFromApplication);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromApplication(Application newFromApplication) {
		if (newFromApplication != fromApplication) {
			NotificationChain msgs = null;
			if (fromApplication != null)
				msgs = ((InternalEObject)fromApplication).eInverseRemove(this, AdlvPackage.APPLICATION__OUTPUT_CONNECTION, Application.class, msgs);
			if (newFromApplication != null)
				msgs = ((InternalEObject)newFromApplication).eInverseAdd(this, AdlvPackage.APPLICATION__OUTPUT_CONNECTION, Application.class, msgs);
			msgs = basicSetFromApplication(newFromApplication, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__FROM_APPLICATION, newFromApplication, newFromApplication));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application getToApplication() {
		if (toApplication != null && toApplication.eIsProxy()) {
			InternalEObject oldToApplication = (InternalEObject)toApplication;
			toApplication = (Application)eResolveProxy(oldToApplication);
			if (toApplication != oldToApplication) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONNECTION__TO_APPLICATION, oldToApplication, toApplication));
			}
		}
		return toApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application basicGetToApplication() {
		return toApplication;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetToApplication(Application newToApplication, NotificationChain msgs) {
		Application oldToApplication = toApplication;
		toApplication = newToApplication;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__TO_APPLICATION, oldToApplication, newToApplication);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToApplication(Application newToApplication) {
		if (newToApplication != toApplication) {
			NotificationChain msgs = null;
			if (toApplication != null)
				msgs = ((InternalEObject)toApplication).eInverseRemove(this, AdlvPackage.APPLICATION__INPUT_CONNECTION, Application.class, msgs);
			if (newToApplication != null)
				msgs = ((InternalEObject)newToApplication).eInverseAdd(this, AdlvPackage.APPLICATION__INPUT_CONNECTION, Application.class, msgs);
			msgs = basicSetToApplication(newToApplication, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__TO_APPLICATION, newToApplication, newToApplication));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Port getToPort() {
		if (toPort != null && toPort.eIsProxy()) {
			InternalEObject oldToPort = (InternalEObject)toPort;
			toPort = (Port)eResolveProxy(oldToPort);
			if (toPort != oldToPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONNECTION__TO_PORT, oldToPort, toPort));
			}
		}
		return toPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Port basicGetToPort() {
		return toPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetToPort(Port newToPort, NotificationChain msgs) {
		Port oldToPort = toPort;
		toPort = newToPort;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__TO_PORT, oldToPort, newToPort);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToPort(Port newToPort) {
		if (newToPort != toPort) {
			NotificationChain msgs = null;
			if (toPort != null)
				msgs = ((InternalEObject)toPort).eInverseRemove(this, AdlvPackage.PORT__CONNECTION_TO, Port.class, msgs);
			if (newToPort != null)
				msgs = ((InternalEObject)newToPort).eInverseAdd(this, AdlvPackage.PORT__CONNECTION_TO, Port.class, msgs);
			msgs = basicSetToPort(newToPort, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__TO_PORT, newToPort, newToPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Port getFromPort() {
		if (fromPort != null && fromPort.eIsProxy()) {
			InternalEObject oldFromPort = (InternalEObject)fromPort;
			fromPort = (Port)eResolveProxy(oldFromPort);
			if (fromPort != oldFromPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONNECTION__FROM_PORT, oldFromPort, fromPort));
			}
		}
		return fromPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Port basicGetFromPort() {
		return fromPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFromPort(Port newFromPort, NotificationChain msgs) {
		Port oldFromPort = fromPort;
		fromPort = newFromPort;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__FROM_PORT, oldFromPort, newFromPort);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFromPort(Port newFromPort) {
		if (newFromPort != fromPort) {
			NotificationChain msgs = null;
			if (fromPort != null)
				msgs = ((InternalEObject)fromPort).eInverseRemove(this, AdlvPackage.PORT__CONNECTION_FROM, Port.class, msgs);
			if (newFromPort != null)
				msgs = ((InternalEObject)newFromPort).eInverseAdd(this, AdlvPackage.PORT__CONNECTION_FROM, Port.class, msgs);
			msgs = basicSetFromPort(newFromPort, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__FROM_PORT, newFromPort, newFromPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Component getToComponent() {
		if (toComponent != null && toComponent.eIsProxy()) {
			InternalEObject oldToComponent = (InternalEObject)toComponent;
			toComponent = (Component)eResolveProxy(oldToComponent);
			if (toComponent != oldToComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONNECTION__TO_COMPONENT, oldToComponent, toComponent));
			}
		}
		return toComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Component basicGetToComponent() {
		return toComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetToComponent(Component newToComponent, NotificationChain msgs) {
		Component oldToComponent = toComponent;
		toComponent = newToComponent;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__TO_COMPONENT, oldToComponent, newToComponent);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setToComponent(Component newToComponent) {
		if (newToComponent != toComponent) {
			NotificationChain msgs = null;
			if (toComponent != null)
				msgs = ((InternalEObject)toComponent).eInverseRemove(this, AdlvPackage.COMPONENT__INPUT_CONNECTION, Component.class, msgs);
			if (newToComponent != null)
				msgs = ((InternalEObject)newToComponent).eInverseAdd(this, AdlvPackage.COMPONENT__INPUT_CONNECTION, Component.class, msgs);
			msgs = basicSetToComponent(newToComponent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONNECTION__TO_COMPONENT, newToComponent, newToComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.CONNECTION__FROM_COMPONENT:
				if (fromComponent != null)
					msgs = ((InternalEObject)fromComponent).eInverseRemove(this, AdlvPackage.COMPONENT__OUTPUT_CONNECTION, Component.class, msgs);
				return basicSetFromComponent((Component)otherEnd, msgs);
			case AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getConnectionConfigurationStep()).basicAdd(otherEnd, msgs);
			case AdlvPackage.CONNECTION__FROM_APPLICATION:
				if (fromApplication != null)
					msgs = ((InternalEObject)fromApplication).eInverseRemove(this, AdlvPackage.APPLICATION__OUTPUT_CONNECTION, Application.class, msgs);
				return basicSetFromApplication((Application)otherEnd, msgs);
			case AdlvPackage.CONNECTION__TO_APPLICATION:
				if (toApplication != null)
					msgs = ((InternalEObject)toApplication).eInverseRemove(this, AdlvPackage.APPLICATION__INPUT_CONNECTION, Application.class, msgs);
				return basicSetToApplication((Application)otherEnd, msgs);
			case AdlvPackage.CONNECTION__TO_PORT:
				if (toPort != null)
					msgs = ((InternalEObject)toPort).eInverseRemove(this, AdlvPackage.PORT__CONNECTION_TO, Port.class, msgs);
				return basicSetToPort((Port)otherEnd, msgs);
			case AdlvPackage.CONNECTION__FROM_PORT:
				if (fromPort != null)
					msgs = ((InternalEObject)fromPort).eInverseRemove(this, AdlvPackage.PORT__CONNECTION_FROM, Port.class, msgs);
				return basicSetFromPort((Port)otherEnd, msgs);
			case AdlvPackage.CONNECTION__TO_COMPONENT:
				if (toComponent != null)
					msgs = ((InternalEObject)toComponent).eInverseRemove(this, AdlvPackage.COMPONENT__INPUT_CONNECTION, Component.class, msgs);
				return basicSetToComponent((Component)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.CONNECTION__FROM_COMPONENT:
				return basicSetFromComponent(null, msgs);
			case AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP:
				return ((InternalEList<?>)getConnectionConfigurationStep()).basicRemove(otherEnd, msgs);
			case AdlvPackage.CONNECTION__FROM_APPLICATION:
				return basicSetFromApplication(null, msgs);
			case AdlvPackage.CONNECTION__TO_APPLICATION:
				return basicSetToApplication(null, msgs);
			case AdlvPackage.CONNECTION__TO_PORT:
				return basicSetToPort(null, msgs);
			case AdlvPackage.CONNECTION__FROM_PORT:
				return basicSetFromPort(null, msgs);
			case AdlvPackage.CONNECTION__TO_COMPONENT:
				return basicSetToComponent(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.CONNECTION__FROM_COMPONENT:
				if (resolve) return getFromComponent();
				return basicGetFromComponent();
			case AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP:
				return getConnectionConfigurationStep();
			case AdlvPackage.CONNECTION__FROM_APPLICATION:
				if (resolve) return getFromApplication();
				return basicGetFromApplication();
			case AdlvPackage.CONNECTION__TO_APPLICATION:
				if (resolve) return getToApplication();
				return basicGetToApplication();
			case AdlvPackage.CONNECTION__TO_PORT:
				if (resolve) return getToPort();
				return basicGetToPort();
			case AdlvPackage.CONNECTION__FROM_PORT:
				if (resolve) return getFromPort();
				return basicGetFromPort();
			case AdlvPackage.CONNECTION__TO_COMPONENT:
				if (resolve) return getToComponent();
				return basicGetToComponent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.CONNECTION__FROM_COMPONENT:
				setFromComponent((Component)newValue);
				return;
			case AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP:
				getConnectionConfigurationStep().clear();
				getConnectionConfigurationStep().addAll((Collection<? extends ConnectionConfigurationStep>)newValue);
				return;
			case AdlvPackage.CONNECTION__FROM_APPLICATION:
				setFromApplication((Application)newValue);
				return;
			case AdlvPackage.CONNECTION__TO_APPLICATION:
				setToApplication((Application)newValue);
				return;
			case AdlvPackage.CONNECTION__TO_PORT:
				setToPort((Port)newValue);
				return;
			case AdlvPackage.CONNECTION__FROM_PORT:
				setFromPort((Port)newValue);
				return;
			case AdlvPackage.CONNECTION__TO_COMPONENT:
				setToComponent((Component)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.CONNECTION__FROM_COMPONENT:
				setFromComponent((Component)null);
				return;
			case AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP:
				getConnectionConfigurationStep().clear();
				return;
			case AdlvPackage.CONNECTION__FROM_APPLICATION:
				setFromApplication((Application)null);
				return;
			case AdlvPackage.CONNECTION__TO_APPLICATION:
				setToApplication((Application)null);
				return;
			case AdlvPackage.CONNECTION__TO_PORT:
				setToPort((Port)null);
				return;
			case AdlvPackage.CONNECTION__FROM_PORT:
				setFromPort((Port)null);
				return;
			case AdlvPackage.CONNECTION__TO_COMPONENT:
				setToComponent((Component)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.CONNECTION__FROM_COMPONENT:
				return fromComponent != null;
			case AdlvPackage.CONNECTION__CONNECTION_CONFIGURATION_STEP:
				return connectionConfigurationStep != null && !connectionConfigurationStep.isEmpty();
			case AdlvPackage.CONNECTION__FROM_APPLICATION:
				return fromApplication != null;
			case AdlvPackage.CONNECTION__TO_APPLICATION:
				return toApplication != null;
			case AdlvPackage.CONNECTION__TO_PORT:
				return toPort != null;
			case AdlvPackage.CONNECTION__FROM_PORT:
				return fromPort != null;
			case AdlvPackage.CONNECTION__TO_COMPONENT:
				return toComponent != null;
		}
		return super.eIsSet(featureID);
	}

} //ConnectionImpl
