/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Attribute;
import fr.supelec.adlv.ConfigurationStep;
import fr.supelec.adlv.ConsumerPort;
import fr.supelec.adlv.Expression;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Consumer Port</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ConsumerPortImpl#getSetExpression <em>Set Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConsumerPortImpl#getSetAttribute <em>Set Attribute</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ConsumerPortImpl#getSteps <em>Steps</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ConsumerPortImpl extends PortImpl implements ConsumerPort {
	/**
	 * The cached value of the '{@link #getSetExpression() <em>Set Expression</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSetExpression()
	 * @generated
	 * @ordered
	 */
	protected Expression setExpression;

	/**
	 * The cached value of the '{@link #getSetAttribute() <em>Set Attribute</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSetAttribute()
	 * @generated
	 * @ordered
	 */
	protected Attribute setAttribute;

	/**
	 * The cached value of the '{@link #getSteps() <em>Steps</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSteps()
	 * @generated
	 * @ordered
	 */
	protected EList<ConfigurationStep> steps;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConsumerPortImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.CONSUMER_PORT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression getSetExpression() {
		if (setExpression != null && setExpression.eIsProxy()) {
			InternalEObject oldSetExpression = (InternalEObject)setExpression;
			setExpression = (Expression)eResolveProxy(oldSetExpression);
			if (setExpression != oldSetExpression) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONSUMER_PORT__SET_EXPRESSION, oldSetExpression, setExpression));
			}
		}
		return setExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression basicGetSetExpression() {
		return setExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSetExpression(Expression newSetExpression) {
		Expression oldSetExpression = setExpression;
		setExpression = newSetExpression;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONSUMER_PORT__SET_EXPRESSION, oldSetExpression, setExpression));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attribute getSetAttribute() {
		if (setAttribute != null && setAttribute.eIsProxy()) {
			InternalEObject oldSetAttribute = (InternalEObject)setAttribute;
			setAttribute = (Attribute)eResolveProxy(oldSetAttribute);
			if (setAttribute != oldSetAttribute) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.CONSUMER_PORT__SET_ATTRIBUTE, oldSetAttribute, setAttribute));
			}
		}
		return setAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attribute basicGetSetAttribute() {
		return setAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSetAttribute(Attribute newSetAttribute) {
		Attribute oldSetAttribute = setAttribute;
		setAttribute = newSetAttribute;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.CONSUMER_PORT__SET_ATTRIBUTE, oldSetAttribute, setAttribute));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ConfigurationStep> getSteps() {
		if (steps == null) {
			steps = new EObjectContainmentWithInverseEList<ConfigurationStep>(ConfigurationStep.class, this, AdlvPackage.CONSUMER_PORT__STEPS, AdlvPackage.CONFIGURATION_STEP__STATE_TRANSITION);
		}
		return steps;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.CONSUMER_PORT__STEPS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSteps()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.CONSUMER_PORT__STEPS:
				return ((InternalEList<?>)getSteps()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.CONSUMER_PORT__SET_EXPRESSION:
				if (resolve) return getSetExpression();
				return basicGetSetExpression();
			case AdlvPackage.CONSUMER_PORT__SET_ATTRIBUTE:
				if (resolve) return getSetAttribute();
				return basicGetSetAttribute();
			case AdlvPackage.CONSUMER_PORT__STEPS:
				return getSteps();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.CONSUMER_PORT__SET_EXPRESSION:
				setSetExpression((Expression)newValue);
				return;
			case AdlvPackage.CONSUMER_PORT__SET_ATTRIBUTE:
				setSetAttribute((Attribute)newValue);
				return;
			case AdlvPackage.CONSUMER_PORT__STEPS:
				getSteps().clear();
				getSteps().addAll((Collection<? extends ConfigurationStep>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.CONSUMER_PORT__SET_EXPRESSION:
				setSetExpression((Expression)null);
				return;
			case AdlvPackage.CONSUMER_PORT__SET_ATTRIBUTE:
				setSetAttribute((Attribute)null);
				return;
			case AdlvPackage.CONSUMER_PORT__STEPS:
				getSteps().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.CONSUMER_PORT__SET_EXPRESSION:
				return setExpression != null;
			case AdlvPackage.CONSUMER_PORT__SET_ATTRIBUTE:
				return setAttribute != null;
			case AdlvPackage.CONSUMER_PORT__STEPS:
				return steps != null && !steps.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //ConsumerPortImpl
