/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Application;
import fr.supelec.adlv.ComponentType;
import fr.supelec.adlv.Connection;
import fr.supelec.adlv.Port;
import fr.supelec.adlv.PortExpression;
import fr.supelec.adlv.TokenType;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Port</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getTokenType <em>Token Type</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getComponent <em>Component</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getConnectionTo <em>Connection To</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getConnectionFrom <em>Connection From</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getConsumerPortExpression <em>Consumer Port Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.PortImpl#getApplication <em>Application</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class PortImpl extends EObjectImpl implements Port {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTokenType() <em>Token Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTokenType()
	 * @generated
	 * @ordered
	 */
	protected TokenType tokenType;

	/**
	 * The cached value of the '{@link #getConnectionTo() <em>Connection To</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnectionTo()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> connectionTo;

	/**
	 * The cached value of the '{@link #getConnectionFrom() <em>Connection From</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnectionFrom()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> connectionFrom;

	/**
	 * The cached value of the '{@link #getConsumerPortExpression() <em>Consumer Port Expression</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConsumerPortExpression()
	 * @generated
	 * @ordered
	 */
	protected EList<PortExpression> consumerPortExpression;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PortImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.PORT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.PORT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TokenType getTokenType() {
		if (tokenType != null && tokenType.eIsProxy()) {
			InternalEObject oldTokenType = (InternalEObject)tokenType;
			tokenType = (TokenType)eResolveProxy(oldTokenType);
			if (tokenType != oldTokenType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.PORT__TOKEN_TYPE, oldTokenType, tokenType));
			}
		}
		return tokenType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TokenType basicGetTokenType() {
		return tokenType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTokenType(TokenType newTokenType, NotificationChain msgs) {
		TokenType oldTokenType = tokenType;
		tokenType = newTokenType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.PORT__TOKEN_TYPE, oldTokenType, newTokenType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTokenType(TokenType newTokenType) {
		if (newTokenType != tokenType) {
			NotificationChain msgs = null;
			if (tokenType != null)
				msgs = ((InternalEObject)tokenType).eInverseRemove(this, AdlvPackage.TOKEN_TYPE__PORT, TokenType.class, msgs);
			if (newTokenType != null)
				msgs = ((InternalEObject)newTokenType).eInverseAdd(this, AdlvPackage.TOKEN_TYPE__PORT, TokenType.class, msgs);
			msgs = basicSetTokenType(newTokenType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.PORT__TOKEN_TYPE, newTokenType, newTokenType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentType getComponent() {
		if (eContainerFeatureID != AdlvPackage.PORT__COMPONENT) return null;
		return (ComponentType)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetComponent(ComponentType newComponent, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newComponent, AdlvPackage.PORT__COMPONENT, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setComponent(ComponentType newComponent) {
		if (newComponent != eInternalContainer() || (eContainerFeatureID != AdlvPackage.PORT__COMPONENT && newComponent != null)) {
			if (EcoreUtil.isAncestor(this, newComponent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newComponent != null)
				msgs = ((InternalEObject)newComponent).eInverseAdd(this, AdlvPackage.COMPONENT_TYPE__PORTS, ComponentType.class, msgs);
			msgs = basicSetComponent(newComponent, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.PORT__COMPONENT, newComponent, newComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getConnectionTo() {
		if (connectionTo == null) {
			connectionTo = new EObjectWithInverseResolvingEList<Connection>(Connection.class, this, AdlvPackage.PORT__CONNECTION_TO, AdlvPackage.CONNECTION__TO_PORT);
		}
		return connectionTo;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getConnectionFrom() {
		if (connectionFrom == null) {
			connectionFrom = new EObjectWithInverseResolvingEList<Connection>(Connection.class, this, AdlvPackage.PORT__CONNECTION_FROM, AdlvPackage.CONNECTION__FROM_PORT);
		}
		return connectionFrom;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PortExpression> getConsumerPortExpression() {
		if (consumerPortExpression == null) {
			consumerPortExpression = new EObjectWithInverseResolvingEList<PortExpression>(PortExpression.class, this, AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION, AdlvPackage.PORT_EXPRESSION__PORT);
		}
		return consumerPortExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application getApplication() {
		if (eContainerFeatureID != AdlvPackage.PORT__APPLICATION) return null;
		return (Application)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetApplication(Application newApplication, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newApplication, AdlvPackage.PORT__APPLICATION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setApplication(Application newApplication) {
		if (newApplication != eInternalContainer() || (eContainerFeatureID != AdlvPackage.PORT__APPLICATION && newApplication != null)) {
			if (EcoreUtil.isAncestor(this, newApplication))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newApplication != null)
				msgs = ((InternalEObject)newApplication).eInverseAdd(this, AdlvPackage.APPLICATION__PORTS, Application.class, msgs);
			msgs = basicSetApplication(newApplication, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.PORT__APPLICATION, newApplication, newApplication));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.PORT__TOKEN_TYPE:
				if (tokenType != null)
					msgs = ((InternalEObject)tokenType).eInverseRemove(this, AdlvPackage.TOKEN_TYPE__PORT, TokenType.class, msgs);
				return basicSetTokenType((TokenType)otherEnd, msgs);
			case AdlvPackage.PORT__COMPONENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetComponent((ComponentType)otherEnd, msgs);
			case AdlvPackage.PORT__CONNECTION_TO:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getConnectionTo()).basicAdd(otherEnd, msgs);
			case AdlvPackage.PORT__CONNECTION_FROM:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getConnectionFrom()).basicAdd(otherEnd, msgs);
			case AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getConsumerPortExpression()).basicAdd(otherEnd, msgs);
			case AdlvPackage.PORT__APPLICATION:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetApplication((Application)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.PORT__TOKEN_TYPE:
				return basicSetTokenType(null, msgs);
			case AdlvPackage.PORT__COMPONENT:
				return basicSetComponent(null, msgs);
			case AdlvPackage.PORT__CONNECTION_TO:
				return ((InternalEList<?>)getConnectionTo()).basicRemove(otherEnd, msgs);
			case AdlvPackage.PORT__CONNECTION_FROM:
				return ((InternalEList<?>)getConnectionFrom()).basicRemove(otherEnd, msgs);
			case AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION:
				return ((InternalEList<?>)getConsumerPortExpression()).basicRemove(otherEnd, msgs);
			case AdlvPackage.PORT__APPLICATION:
				return basicSetApplication(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case AdlvPackage.PORT__COMPONENT:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.COMPONENT_TYPE__PORTS, ComponentType.class, msgs);
			case AdlvPackage.PORT__APPLICATION:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.APPLICATION__PORTS, Application.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.PORT__NAME:
				return getName();
			case AdlvPackage.PORT__TOKEN_TYPE:
				if (resolve) return getTokenType();
				return basicGetTokenType();
			case AdlvPackage.PORT__COMPONENT:
				return getComponent();
			case AdlvPackage.PORT__CONNECTION_TO:
				return getConnectionTo();
			case AdlvPackage.PORT__CONNECTION_FROM:
				return getConnectionFrom();
			case AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION:
				return getConsumerPortExpression();
			case AdlvPackage.PORT__APPLICATION:
				return getApplication();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.PORT__NAME:
				setName((String)newValue);
				return;
			case AdlvPackage.PORT__TOKEN_TYPE:
				setTokenType((TokenType)newValue);
				return;
			case AdlvPackage.PORT__COMPONENT:
				setComponent((ComponentType)newValue);
				return;
			case AdlvPackage.PORT__CONNECTION_TO:
				getConnectionTo().clear();
				getConnectionTo().addAll((Collection<? extends Connection>)newValue);
				return;
			case AdlvPackage.PORT__CONNECTION_FROM:
				getConnectionFrom().clear();
				getConnectionFrom().addAll((Collection<? extends Connection>)newValue);
				return;
			case AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION:
				getConsumerPortExpression().clear();
				getConsumerPortExpression().addAll((Collection<? extends PortExpression>)newValue);
				return;
			case AdlvPackage.PORT__APPLICATION:
				setApplication((Application)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.PORT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case AdlvPackage.PORT__TOKEN_TYPE:
				setTokenType((TokenType)null);
				return;
			case AdlvPackage.PORT__COMPONENT:
				setComponent((ComponentType)null);
				return;
			case AdlvPackage.PORT__CONNECTION_TO:
				getConnectionTo().clear();
				return;
			case AdlvPackage.PORT__CONNECTION_FROM:
				getConnectionFrom().clear();
				return;
			case AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION:
				getConsumerPortExpression().clear();
				return;
			case AdlvPackage.PORT__APPLICATION:
				setApplication((Application)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.PORT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case AdlvPackage.PORT__TOKEN_TYPE:
				return tokenType != null;
			case AdlvPackage.PORT__COMPONENT:
				return getComponent() != null;
			case AdlvPackage.PORT__CONNECTION_TO:
				return connectionTo != null && !connectionTo.isEmpty();
			case AdlvPackage.PORT__CONNECTION_FROM:
				return connectionFrom != null && !connectionFrom.isEmpty();
			case AdlvPackage.PORT__CONSUMER_PORT_EXPRESSION:
				return consumerPortExpression != null && !consumerPortExpression.isEmpty();
			case AdlvPackage.PORT__APPLICATION:
				return getApplication() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //PortImpl
