/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Attribute;
import fr.supelec.adlv.Expression;
import fr.supelec.adlv.ProducerPort;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Producer Port</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ProducerPortImpl#getOutputAttribute <em>Output Attribute</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ProducerPortImpl#getEventEmitExpression <em>Event Emit Expression</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ProducerPortImpl extends PortImpl implements ProducerPort {
	/**
	 * The cached value of the '{@link #getOutputAttribute() <em>Output Attribute</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutputAttribute()
	 * @generated
	 * @ordered
	 */
	protected Attribute outputAttribute;

	/**
	 * The cached value of the '{@link #getEventEmitExpression() <em>Event Emit Expression</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventEmitExpression()
	 * @generated
	 * @ordered
	 */
	protected Expression eventEmitExpression;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProducerPortImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.PRODUCER_PORT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attribute getOutputAttribute() {
		if (outputAttribute != null && outputAttribute.eIsProxy()) {
			InternalEObject oldOutputAttribute = (InternalEObject)outputAttribute;
			outputAttribute = (Attribute)eResolveProxy(oldOutputAttribute);
			if (outputAttribute != oldOutputAttribute) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.PRODUCER_PORT__OUTPUT_ATTRIBUTE, oldOutputAttribute, outputAttribute));
			}
		}
		return outputAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attribute basicGetOutputAttribute() {
		return outputAttribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOutputAttribute(Attribute newOutputAttribute) {
		Attribute oldOutputAttribute = outputAttribute;
		outputAttribute = newOutputAttribute;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.PRODUCER_PORT__OUTPUT_ATTRIBUTE, oldOutputAttribute, outputAttribute));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression getEventEmitExpression() {
		if (eventEmitExpression != null && eventEmitExpression.eIsProxy()) {
			InternalEObject oldEventEmitExpression = (InternalEObject)eventEmitExpression;
			eventEmitExpression = (Expression)eResolveProxy(oldEventEmitExpression);
			if (eventEmitExpression != oldEventEmitExpression) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION, oldEventEmitExpression, eventEmitExpression));
			}
		}
		return eventEmitExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Expression basicGetEventEmitExpression() {
		return eventEmitExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEventEmitExpression(Expression newEventEmitExpression, NotificationChain msgs) {
		Expression oldEventEmitExpression = eventEmitExpression;
		eventEmitExpression = newEventEmitExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION, oldEventEmitExpression, newEventEmitExpression);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventEmitExpression(Expression newEventEmitExpression) {
		if (newEventEmitExpression != eventEmitExpression) {
			NotificationChain msgs = null;
			if (eventEmitExpression != null)
				msgs = ((InternalEObject)eventEmitExpression).eInverseRemove(this, AdlvPackage.EXPRESSION__PRODUCER_PORT, Expression.class, msgs);
			if (newEventEmitExpression != null)
				msgs = ((InternalEObject)newEventEmitExpression).eInverseAdd(this, AdlvPackage.EXPRESSION__PRODUCER_PORT, Expression.class, msgs);
			msgs = basicSetEventEmitExpression(newEventEmitExpression, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION, newEventEmitExpression, newEventEmitExpression));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION:
				if (eventEmitExpression != null)
					msgs = ((InternalEObject)eventEmitExpression).eInverseRemove(this, AdlvPackage.EXPRESSION__PRODUCER_PORT, Expression.class, msgs);
				return basicSetEventEmitExpression((Expression)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION:
				return basicSetEventEmitExpression(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.PRODUCER_PORT__OUTPUT_ATTRIBUTE:
				if (resolve) return getOutputAttribute();
				return basicGetOutputAttribute();
			case AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION:
				if (resolve) return getEventEmitExpression();
				return basicGetEventEmitExpression();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.PRODUCER_PORT__OUTPUT_ATTRIBUTE:
				setOutputAttribute((Attribute)newValue);
				return;
			case AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION:
				setEventEmitExpression((Expression)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.PRODUCER_PORT__OUTPUT_ATTRIBUTE:
				setOutputAttribute((Attribute)null);
				return;
			case AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION:
				setEventEmitExpression((Expression)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.PRODUCER_PORT__OUTPUT_ATTRIBUTE:
				return outputAttribute != null;
			case AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION:
				return eventEmitExpression != null;
		}
		return super.eIsSet(featureID);
	}

} //ProducerPortImpl
