/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.parser;

import antlr.CommonAST;
import antlr.Token;
import antlr.collections.AST;

public class NumberedAST extends CommonAST {
	private static final long serialVersionUID = -7485808606490719799L;

	private int line = 0, col = 0;

	protected void setLine(int line) {
		this.line = line;
	}

	@Override
	public int getLine() {
		return line;
	}

	protected void setColumn(int col) {
		this.col = col;
	}

	@Override
	public int getColumn() {
		return col;
	}

	public NumberedAST() {
		super();
	}

	public NumberedAST(Token tok) {
		super(tok);
	}

	@Override
	public void initialize(Token tok) {
		super.initialize(tok);
		setLine(tok.getLine());
		setColumn(tok.getColumn());
	}

	@Override
	public void initialize(AST t) {
		super.initialize(t);
		//NumberedAST nt = (NumberedAST)t;
		//setLine(nt.getLine());
		setLine(t.getLine());
		setColumn(t.getColumn());
	}
}
